/**
 * Copyright (c) 2006 Sascha Grau
 * contact: rostar@graui.de
 */

#ifndef ELEMENT_H_
#define ELEMENT_H_

#include <cstdlib>

/**
 * A simple Element class for a double linked list.
 */

template<class Entry> struct Element {

    Element<Entry>* prev;
    Element<Entry>* next;
    Entry entry;

    Element(const Entry e);
    Element(const Element<Entry>&);
};

template<class Entry>
Element<Entry>::Element(const Entry e) {
    next = NULL;
    prev = NULL;
    this->entry = e;
}

template<class Entry>
Element<Entry>::Element(const Element& e) {
    this->next = e->next;
    this->prev = e->prev;
    this->entry = e->entry;
}

#endif /* ELEMENT_H_ */
