/**
 * Copyright (c) 2006 Sascha Grau
 * contact: rostar@graui.de
 */

#ifndef MULTIPART_H_
#define MULTIPART_H_

#include <climits>

/**
 * A union-find data structure, capable of managing
 * multiple partitions of the same base set of an
 * integer sequence 0 to n-1.
 */
class Multipart {

private:
    unsigned long n;
    unsigned int partnum;

    unsigned long** pred;
    unsigned int** rank;

public:

    static const unsigned long error = ULONG_MAX;

    Multipart(unsigned long n, unsigned int partnum = 1);
    ~Multipart();

    unsigned long find(unsigned long elem, unsigned int part = 0);
    unsigned long unite(unsigned long elem1, 
                        unsigned long elem2, unsigned int part = 0);

    unsigned long part_cnt(unsigned int part = 0);

    void print_part(unsigned int part = 0);
    void dbg_print_part(unsigned int part = 0);

};

#endif /* MULTIPART_H_ */
