/**
 * Copyright (c) 2006 Sascha Grau
 * contact: rostar@graui.de
 */

#ifndef GRAPH_FACTORY_H_
#define GRAPH_FACTORY_H_

#include <iostream>
#include <vector>

#include "../ds/graph.h"
#include "graphioexception.h"

class GraphFactory {

protected:
    std::vector<long int> costs;
    Graph* permuteBase;

    bool permuteCostVec();
    Graph* assignWeights();

public:
    GraphFactory();
    ~GraphFactory();

    static Graph* fromFile(char* path)
                throw(GraphIOException);
    static Graph* copyGraph(Graph* from);

    Graph* permuteGraphFromFile(char* path)
                throw(GraphIOException);
    Graph* permuteGraph();

};

#endif /* GRAPH_FRACTORY_H_*/
